#import "day.h"

@implementation day
- (id) init {
	self = [super init];
	if (self != nil) {
		dayName = [[NSString alloc] init];
		dayLessons = [[NSMutableArray alloc] init];
	}
	return self;
}

-(id)initWithDayName:(NSString *)theName
{
	self = [super init];
	dayName = [[NSString alloc]initWithString:theName];
	dayLessons = [[NSMutableArray alloc] init];
	return self;
}

//________________________________________________________________________________________________
-(void)setDayName: (NSString *)dayname
{
	[dayName release];
	dayName = [dayname retain];
}

-(void)addLesson: (lesson *)theLesson;
{
	[dayLessons addObject:theLesson];
}

-(NSString *)dayName
{
	return dayName;
}

-(NSMutableArray *)dayLessons
{
	return dayLessons;
}


-(void)showAllLessons
{
	int i;
	NSLog(@"%@\n",dayName);
	for (i=0; i<[dayLessons count]; i++) {
		[[dayLessons objectAtIndex:i]display];
	}
}

//________________________________________________________________________________________________
-(void)encodeWithCoder:(NSCoder *)encoder
{
	[encoder encodeObject:dayName];
	[encoder encodeObject:dayLessons];
}

-(id)initWithCoder:(NSCoder *)decoder
{
	dayName = [[decoder decodeObject]retain];
	dayLessons = [[decoder decodeObject]retain];
	return self;
}
//________________________________________________________________________________________________

- (void) dealloc {
	NSLog(@"Day Deallocating...\n");
	[dayName release];
	[dayLessons release];
	[super dealloc];
}


@end
