#import "lesson.h"

@implementation lesson

-(id)initWithLessonName: (NSString *)theName andlessonHourStart: (NSString *)theHours
   andLessonAssignments: (NSString *)theAssignments
{
	self = [super init];
	lessonName			= [theName retain];
	lessonHourStart			= [theHours retain];
	lessonAssignments	= [theAssignments retain];
	return self;
}


//__________________________________________________________
-(void)setLessonName:(NSString* )theLessonName 
  andlessonHourStart:(NSString *)thelessonHourStart 
	andLessonHourEnd:(NSString *)theLessonHourEnd
andLessonAssignments:(NSString *)thelessonAssignments
{
	[self setLessonName:theLessonName];
	[self setlessonHourStart:thelessonHourStart];
	[self setLessonHourEnd:theLessonHourEnd];
	[self setLessonAssignments:thelessonAssignments];

}

-(void)setLessonName:(NSString* )theLessonName
{
	[lessonName release];
	[theLessonName retain];
	lessonName = theLessonName;
}

-(void)setlessonHourStart:(NSString *)thelessonHourStart;
{
	[lessonHourStart release];
	[thelessonHourStart retain];
	lessonHourStart = thelessonHourStart;
}

-(void)setLessonHourEnd:(NSString *)theLessonHourEnd
{
	[lessonHourEnd release];
	[theLessonHourEnd retain];
	lessonHourEnd = theLessonHourEnd;
}

-(void)setLessonAssignments:(NSString *)theString {
    if (lessonAssignments != theString) {
		[lessonAssignments release];
		lessonAssignments = [theString copy];
    }
    NSLog(@"Setting the new assignments to: %@", lessonAssignments);
}
//__________________________________________________________
//gettters
-(NSString *)lessonName{return lessonName;}
-(NSString *)lessonAssignments{return lessonAssignments;}
-(NSString *)lessonHourStart{return lessonHourStart;}
-(NSString *)lessonHourEnd{return lessonHourEnd;}

-(void)display
{
	NSLog(@"****%@****\nHours: %@\n Assignments::\n%@\n\n",lessonName,lessonHourStart,lessonAssignments);
}

-(NSComparisonResult)compareHourStart:(id)element
{
	return [lessonHourStart compare:[element lessonHourStart]];
}

-(NSComparisonResult)compareHourEnd:(id)element
{
	return [lessonHourEnd compare:[element lessonHourEnd]];
}

//____________________________________________________
-(void)encodeWithCoder: (NSCoder *)encoder
{
	[encoder encodeObject:lessonName];
	[encoder encodeObject:lessonHourStart];
	[encoder encodeObject:lessonAssignments];
	[encoder encodeObject:lessonHourEnd];
}

-(id)initWithCoder:(NSCoder *)decoder
{
	lessonName = [[decoder decodeObject]retain];
	lessonHourStart = [[decoder decodeObject]retain];
	lessonAssignments = [[decoder decodeObject]retain];
	lessonHourEnd = [[decoder decodeObject]retain];
	return self;
}
//_____________________________________________________
- (void) dealloc {
	NSLog(@"Lesson Deallocating...\n");
	[lessonName release];
	[lessonAssignments release];
	[lessonHourStart release];
	[lessonHourEnd release];
	//NSLog(@"%i%i%i%i", [lessonAssignments retainCount],[lessonHourEnd retainCount], [lessonHourStart retainCount], [lessonName retainCount]);
	[super dealloc];
}


@end
